%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 1
%global with_check 1
%global with_unit_test 1
%else
%global with_devel 1
%global with_bundled 0
%global with_debug 1
%global with_check 1
%global with_unit_test 1
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%if ! 0%{?gobuild:1}
%define gobuild(o:) go build -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x %{?**};
%endif

%global provider        github
%global provider_tld    com
%global project         Masterminds
%global repo            glide
# https://github.com/Masterminds/glide
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          8032c28b91ee6b8b71655bb622f5aac497011723
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           glide
Version:        0.12.1
Release:        0.1.git%{shortcommit}%{?dist}
Summary:        Package Management for Golang
# Detected licences
# - MIT/X11 (BSD like) at 'LICENSE'
License:        MIT
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%if ! 0%{?with_bundled}
# glide.go
BuildRequires: golang(github.com/codegangsta/cli)

# Remaining dependencies not included in main packages
BuildRequires: golang(github.com/urfave/cli)
BuildRequires: golang(github.com/Masterminds/semver)
BuildRequires: golang(gopkg.in/yaml.v2)
BuildRequires: golang(github.com/Masterminds/vcs)
%endif

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check} && ! 0%{?with_bundled}
BuildRequires: golang(github.com/Masterminds/semver)
BuildRequires: golang(github.com/Masterminds/vcs)
BuildRequires: golang(github.com/codegangsta/cli)
BuildRequires: golang(github.com/urfave/cli)
BuildRequires: golang(gopkg.in/yaml.v2)
%endif

Requires:      golang(github.com/Masterminds/semver)
Requires:      golang(github.com/Masterminds/vcs)
Requires:      golang(github.com/codegangsta/cli)
Requires:      golang(github.com/urfave/cli)
Requires:      golang(gopkg.in/yaml.v2)

Provides:      golang(%{import_path}/action) = %{version}-%{release}
Provides:      golang(%{import_path}/cache) = %{version}-%{release}
Provides:      golang(%{import_path}/cfg) = %{version}-%{release}
Provides:      golang(%{import_path}/dependency) = %{version}-%{release}
Provides:      golang(%{import_path}/gb) = %{version}-%{release}
Provides:      golang(%{import_path}/godep) = %{version}-%{release}
Provides:      golang(%{import_path}/godep/strip) = %{version}-%{release}
Provides:      golang(%{import_path}/gom) = %{version}-%{release}
Provides:      golang(%{import_path}/gpm) = %{version}-%{release}
Provides:      golang(%{import_path}/importer) = %{version}-%{release}
Provides:      golang(%{import_path}/mirrors) = %{version}-%{release}
Provides:      golang(%{import_path}/msg) = %{version}-%{release}
Provides:      golang(%{import_path}/path) = %{version}-%{release}
Provides:      golang(%{import_path}/repo) = %{version}-%{release}
Provides:      golang(%{import_path}/tree) = %{version}-%{release}
Provides:      golang(%{import_path}/util) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/Masterminds/semver) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/Masterminds/vcs) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/codegangsta/cli) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/codegangsta/cli/altsrc) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/gopkg.in/yaml.v2) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%package unit-test-devel
Summary:         Unit tests for %{name} package
%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%if 0%{?with_check} && ! 0%{?with_bundled}
BuildRequires: golang(gopkg.in/check.v1)
%endif

Requires:      golang(gopkg.in/check.v1)

%description unit-test-devel
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}

%build
mkdir -p src/%{provider}.%{provider_tld}/%{project}
ln -s ../../../ src/%{import_path}

%if ! 0%{?with_bundled}
export GOPATH=$(pwd):%{gopath}
%else
export GOPATH=$(pwd):$(pwd)/Godeps/_workspace:%{gopath}
%endif

%gobuild -o bin/glide %{import_path}/

%install
install -d -p %{buildroot}%{_bindir}
install -p -m 0755 bin/glide %{buildroot}%{_bindir}

# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go" | grep -v "Godeps/_workspace") ; do
    dirprefix=$(dirname $file)
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$dirprefix
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list

    while [ "$dirprefix" != "." ]; do
        echo "%%dir %%{gopath}/src/%%{import_path}/$dirprefix" >> devel.file-list
        dirprefix=$(dirname $dirprefix)
    done
done
%endif

# testing files for this project
%if 0%{?with_unit_test} && 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test-devel.file-list
for file in $(find . -iname "*_test.go" | grep -v "Godeps/_workspace") ; do
    dirprefix=$(dirname $file)
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$dirprefix
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test-devel.file-list

    while [ "$dirprefix" != "." ]; do
        echo "%%dir %%{gopath}/src/%%{import_path}/$dirprefix" >> devel.file-list
        dirprefix=$(dirname $dirprefix)
    done
done

install -d -p %{buildroot}/%{gopath}/src/%{import_path}/testdata
echo "%%{gopath}/src/%%{import_path}/testdata" >> unit-test-devel.file-list
cp -rpav testdata/* %{buildroot}/%{gopath}/src/%{import_path}/testdata/.
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%else
export GOPATH=%{buildroot}/%{gopath}:$(pwd)/Godeps/_workspace:%{gopath}
%endif

%if ! 0%{?gotest:1}
%global gotest go test
%endif

%gotest %{import_path}
%gotest %{import_path}/action
%gotest %{import_path}/cache
%gotest %{import_path}/cfg
# relevent only for vendor directory from within a project
#%%gotest %%{import_path}/dependency
%gotest %{import_path}/godep/strip
%gotest %{import_path}/mirrors
%gotest %{import_path}/path
%gotest %{import_path}/repo
%gotest %{import_path}/tree
#%%gotest %%{import_path}/util
%endif

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files
%license LICENSE
%doc CHANGELOG.md README.md
%{_bindir}/glide

%if 0%{?with_devel}
%files devel -f devel.file-list
%license LICENSE
%doc CHANGELOG.md README.md
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%files unit-test-devel -f unit-test-devel.file-list
%license LICENSE
%doc CHANGELOG.md README.md
%endif

%changelog
* Tue Sep 06 2016 jchaloup <jchaloup@redhat.com> - 0-0.1.git8032c28
- First package for Fedora
  resolves: #1373623
